import math
import random

def partition(arr, start, stop, pivot_ix):
    """Partition arr[start:stop] around pivot."""
    left = []
    pivot_count = 0
    right = []
    pivot = arr[pivot_ix]
    for ix in range(start, stop):
        if arr[ix] < pivot:
            left.append(arr[ix])
        elif arr[ix] == pivot:
            pivot_count += 1
        else:
            right.append(arr[ix])
    ix = start
    for x in left:
        arr[ix] = x
        ix += 1
    for i in range(pivot_count):
        arr[ix] = pivot
        ix += 1
    for x in right:
        arr[ix] = x
        ix += 1
    return start + len(left)

def quickselect(arr, k, start, stop):
    """Finds kth order statistic in numbers[start:stop])"""
    if k > len(arr):
        return math.inf
    
    pivot_ix = random.randrange(start, stop)
    pivot_ix = partition(arr, start, stop, pivot_ix)
    pivot_order = pivot_ix + 1
    if pivot_order == k:
        return arr[pivot_ix]
    elif pivot_order < k:
        return quickselect(arr, k, pivot_ix + 1, stop)
    else:
        return quickselect(arr, k, start, pivot_ix)


def knn_distance(arr, q, k):
    less = []
    more = []
    
    for ele in arr:
        if ele <= q:
            less.append(ele)
        else:
            more.append(ele)
            
    from_less = quickselect(less, len(less) - k  + 1, 0, len(less))
    from_more = quickselect(more, k, 0, len(more))
    
    
    out_diff = 0
    out_val = 0
    if abs(from_less - q) < abs(from_more - q):
        out_diff = abs(q - from_less)
        out_val = from_less
    else:
        out_diff = abs(q - from_more)
        out_val = from_more
    
    return (out_diff, out_val)
    
    

        